<template>
    <div class="container-fluid">
        <div class="row clearfix">
            <div class="col-12 ">
                <div class="row clearfix">
                    <div
                        v-for="i of agency"
                        :key="i.id"
                        :class="
                            editing
                                ? editing.id == i.id
                                    ? 'col-md-12'
                                    : 'd-none'
                                : 'col-md-6 col-sm-12'
                        "
                    >
                        <div
                            :class="
                                editing
                                    ? editing.id == i.id
                                        ? 'card xl-salmon member-card doctor'
                                        : 'card xl-blue member-card doctor'
                                    : 'card xl-blue member-card doctor'
                            "
                        >
                            <div class="body">
                                <div class="member-thumb">
                                    <img
                                        :src="i.logo ? i.logo : '/img/logo.png'"
                                        class="img-fluid"
                                        alt="profile-image"
                                    />
                                </div>
                                <div class="detail">
                                    <h4
                                        class="m-b-0"
                                        :class="
                                            template == 'dark'
                                                ? 'text-dark'
                                                : ''
                                        "
                                    >
                                        {{ i.nombre }}
                                    </h4>

                                    <a
                                        href="javascript:void(0);"
                                        @click="selectAgency(i)"
                                        class="btn btn-default btn-round btn-simple"
                                        >Configurar Rango de edades</a
                                    >
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-12">
                <div class="row clearfix">
                    <div v-if="editing" class="col-md-12">
                        <div
                            class="card member-card doctor"
                            :class="
                                template == 'dark' ? 'bg-black' : 'xl-blue-ol'
                            "
                        >
                            <div class="body">
                                <div v-if="createRango" class="row">
                                    <h6 class="text-center">
                                        Agregar nueva poliza
                                    </h6>
                                    <div class="col-md-12">
                                        <div class="form-group">
                                            <input
                                                type="text"
                                                class="form-control"
                                                v-model="newRango.plan_name"
                                                placeholder="Nombre de la poliza"
                                            />
                                        </div>
                                    </div>
                                    <div class="col-md-12">
                                        <div class="form-group">
                                            <input
                                                type="number"
                                                min="0"
                                                step="1"
                                                class="form-control"
                                                v-model="newRango.amount"
                                                placeholder="Edad máxima"
                                            />
                                        </div>
                                    </div>
                                    <button
                                        @click="saveRango()"
                                        class="btn btn-success btn-block"
                                    >
                                        {{
                                            successMsg
                                                ? "Salir"
                                                : "Nuevo Rango de edades"
                                        }}
                                    </button>
                                </div>
                                <table v-else class="table m-b-0 table-hover">
                                    <thead>
                                        <tr>
                                            <th></th>
                                            <th
                                                v-for="i of rangoPoliza"
                                                :key="'rangoPoliza' + i.id"
                                            >
                                                {{ i.plan_name }} <br />
                                                {{ i.amount }}
                                            </th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <template v-for="ran of rangoEdad">
                                            <tr :key="'rangoEdad' + ran.id">
                                                <td>
                                                    {{ ran.min }} -
                                                    {{ ran.max }}
                                                </td>
                                                <td
                                                    v-for="i of rangoPoliza"
                                                    :key="'matriz' + i.id"
                                                    @click="
                                                        asiganarValoresEditar(
                                                            i.id,
                                                            ran.id
                                                        )
                                                    "
                                                >
                                                    <input
                                                        v-if="
                                                            editarRango.rango_edades_id ==
                                                                ran.id &&
                                                                editarRango.rango_alternativas_id ==
                                                                    i.id
                                                        "
                                                        type="number"
                                                        placeholder="precio"
                                                        class="form-control"
                                                        @blur="postMatriz()"
                                                        v-model="
                                                            editarRango.precio
                                                        "
                                                    />

                                                    <span v-else>
                                                        {{
                                                            obtenerMatriz(
                                                                ran.matriz,
                                                                i.id
                                                            )
                                                        }}
                                                    </span>
                                                </td>
                                            </tr>
                                        </template>
                                    </tbody>
                                </table>
                                <button
                                    @click="clear()"
                                    class="btn btn-danger btn-block"
                                >
                                    {{ successMsg ? "Salir" : "Cancelar" }}
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
import { required, minLength, between, email } from "vuelidate/lib/validators";
export default {
    props: ["a", "lang", "t"],
    mounted() {
        this.setFiltered();
    },
    data() {
        return {
            template: this.t,

            field: this.lang,
            selecting: {
                id: null
            },
            successMsg: null,
            createRango: null,
            agency: this.a,
            editing: null,
            rangoEdad: null,
            rangoPoliza: null,
            search: null,
            conUsuario: null,
            sinUsuario: null,
            resultado: null,
            newRango: { plan_name: null, amount: null },
            editarRango: { rango_alternativas_id: null, rango_edades_id: null }
        };
    },
    validations: {},
    methods: {
        setFiltered() {
            let a =
                JSON.parse(localStorage.getItem("aseguradora_selected")) ??
                null;
            if (a) {
                this.selecting.id = a.id;
                this.editing = a;
                this.getRangosPolizas(this.editing.id);
                this.getRangosEdad(this.editing.id);
            }
        },
        selectAgency(ag) {
            this.editing = ag;
            localStorage.setItem("aseguradora_selected", JSON.stringify(ag));
            this.$emit("select-agency", ag);
            this.getRangosPolizas(this.editing.id);
            this.getRangosEdad(this.editing.id);
        },
        clear() {
            this.newRango = { plan_name: null, amount: null };
            this.editarRango = {
                rango_alternativas_id: null,
                rango_edades_id: null
            };
            this.selecting.id = null;
            this.sinUsuario = null;
            this.editing = null;
            this.successMsg = null;
            this.user = {};
            this.errorMsg = null;
            this.createRango = null;
            this.rangoEdad = null;
            this.rangoPoliza = null;
            localStorage.removeItem("aseguradora_selected");
            this.$emit("select-agency", null);
        },
        getRangosPolizas(e) {
            return new Promise((res, rej) => {
                axios
                    .get("/api/aseguradora/polizas", {
                        params: {
                            aseguradora: e
                        }
                    })
                    .then(response => {
                        this.rangoPoliza = response.data;
                        res(true);
                        return false;
                    })
                    .catch(err => {
                        console.error(err);
                        rej(false);
                    });
            });
        },
        getRangosEdad(e) {
            return new Promise((res, rej) => {
                axios
                    .get("/api/aseguradora/rango", {
                        params: {
                            aseguradora: e
                        }
                    })
                    .then(response => {
                        this.rangoEdad = response.data;
                        res(true);
                        return false;
                    })
                    .catch(err => {
                        console.error(err);
                        rej(false);
                    });
            });
        },
        asiganarValoresEditar(x, y) {
            this.editarRango.rango_alternativas_id = x;
            this.editarRango.rango_edades_id = y;
        },
        obtenerMatriz(x, y) {
            let value = x.find(el => el.rango_alternativas_id == y);
            return value ? value.precio : 0;
        },
        postMatriz() {
            axios
                .post("/api/aseguradora/matriz", this.editarRango)
                .then(res => {
                    this.editarRango = {
                        rango_alternativas_id: null,
                        rango_edades_id: null
                    };
                    this.getRangosEdad(this.editing.id);
                })
                .catch(err => {
                    console.log(err);
                });
        }
    }
};
</script>
